;
; rotiert alle punkte in xaus,yaus,zaus um grad(x,y,z) mit            
;   sin(x,y,z) und cos(x,y,z)                                         
; IN                                                                  
;  ebx=gradx                                                          
;  edi=grady                                                          
;  esi=gradz                                                          
;
 a11  dw ?                                                              
 a22  dw ?                                                              
 a33  dw ?                                                              
 sinx  dw ?                                    
 siny  dw ?                                    
 sinz  dw ?                                    
 cosx  dw ?                                    
 cosy  dw ?                     
 cosz  dw ?          
rotieren_all:
      	pushad       
	and	ebx,511                                                      
     	and	esi,511               
	and	edi,511               
	add	ebx,ebx             
   	add	esi,esi
	add	edi,edi             
	mov	ax,w [sinus+ebx]
 	mov	cx,w [sinus+edi]  	
	mov	dx,w [sinus+esi]        
	mov	sinx,ax	
	mov	siny,cx 
	mov	sinz,dx 
	mov	ax,w [cosinus+ebx] 		
	mov	cx,w [cosinus+edi]
	mov	dx,w [cosinus+esi]
	mov	cosx,ax 
  	mov	cosy,cx           
 	mov 	cosz,dx
      	movzx	ebx,anzahlvektor		
 	add	ebx,ebx                         
@next:                                  
	sub	ebx,2                   
	mov	ax,[yaus+ebx]
	add	ax,xwegtr
	mov	di,cosx          
 	imul	di               
 	shrd	esi,edx,16              
 	mov	si,ax                   
	mov	ax,[zaus+ebx]
	add	ax,zwegtr
	mov	di,sinx  
 	imul	di                   
	shrd	ecx,edx,16              
	mov	cx,ax                   
	add	esi,ecx                 
	sar	esi,9                   
	mov	a11,si   ;a11:= ( cosx*y + sinx*z)   shr 9;
	mov	ax,[yaus+ebx]
	add	ax,ywegtr
	mov	di,sinx          
 	imul	di               
      	shrd	esi,edx,16              
	mov 	si,ax                   
	mov	ax,[zaus+ebx]
	add	ax,zwegtr
	mov	di,cosx          
 	imul	di               
	shrd	ecx,edx,16              
	mov	cx,ax                   
	sub	ecx,esi          
	sar	ecx,9            
	mov	a22,cx  ;a22:=(-sinx*y + cosx*z) shr 9;
	mov	ax,[xaus+ebx]
	add	ax,xwegtr
	mov	di,cosy           
 	imul	di                
	shrd	esi,edx,16        
	mov	si,ax             
	mov	ax,a22            
	mov	di,siny           
	imul	di                
	shrd	ecx,edx,16            
	mov	cx,ax             
 	sub	esi,ecx           
	sar	esi,9             
	mov	a33,si  ;a33:=( cosy*x - siny*a2 ) shr 9;
	mov	ax,[xaus+ebx]
	add	ax,xwegtr
	mov	di,siny           
	imul	di                
	shrd	esi,edx,16        
	mov	si,ax             
	mov	ax,a22            
	mov	di,cosy           
 	imul	di                
	shrd	ecx,edx,16        
	mov	cx,ax             
	add	esi,ecx           
	sar	esi,9    
	add	esi,zweg 
 	mov	[zrot+ebx],si  ;rotiertz:=( siny*x   + cosy*a2 ) shr 9
	mov	ax,a33                                                
	mov	di,cosz                                               
	imul	di                                                    
	shrd	esi,edx,16                                            
	mov	si,ax    
	mov	ax,a11   
	mov	di,sinz  
	imul	di       
	shrd	ecx,edx,16
	mov	cx,ax    
	add	esi,ecx  
	sar	esi,9    
	add	esi,xweg 
 	mov	[xrot+ebx],si  ;rotiertx:=( cosz*a3  + sinz*a1 ) shr 9;
	mov	ax,a33                                                 
	mov	di,sinz                                                
	imul	di                                                     
	shrd	esi,edx,16                                             
	mov	si,ax    
	mov	ax,a11     
	mov	di,cosz    
	imul	di         
	shrd	ecx,edx,16  
	mov	cx,ax       
	sub	ecx,esi     
 	sar	ecx,9    
 	add	ecx,yweg 
 	mov	[yrot+ebx],cx  ;rotierty:=(-sinz*a3  + cosz*a1 ) shr 9
	movsx	esi,[zrot+ebx]
	add	esi,200;40
 	or	esi,esi  
 	jnz	@nichtnull                                            
 	inc	esi                                                   
@nichtnull:              
 	cmp	esi,0    
 	jns	@nichtnegativ
 	neg	esi      
@nichtnegativ:               
	movsx	eax,[xrot+ebx]
	sal	eax,8        
	mov	edx,eax 
	sar	edx,31  
	idiv	esi     
	add	ax,linksrechts
	mov	[xanz+ebx],ax  ;xx[pixel]:=xraus+(longint(rotiertx) shl 8) div rotiertz;
	movsx	eax,[yrot+ebx]
	sal	eax,8   
	mov	edx,eax 
	sar	edx,31  
	idiv	esi     
	add	ax,obenunten
	mov	[yanz+ebx],ax   ;yy[pixel]:=yraus+(longint(rotierty) shl 8) div rotiertz;
	or	ebx,ebx 
    	jne  	@next   
    	popad           
ret                     

;
; rotiert punkt in xaus,yaus,zaus um grad(x,y,z) mit
;   sin(x,y,z) und cos(x,y,z)                                         
; IN                                                                  
;  ebx=gradx                                                          
;  edi=grady                                                          
;  esi=gradz                                                          
;
rotieren:
	pushad
	and	ebx,511                                                      
	and	esi,511               
	and	edi,511               
	add	ebx,ebx             
   	add	esi,esi
	add	edi,edi             
	mov	ax,w [sinus+ebx]
 	mov	cx,w [sinus+edi]  	
	mov	dx,w [sinus+esi]        
	mov	sinx,ax	
	mov	siny,cx 
	mov	sinz,dx 
	mov	ax,w [cosinus+ebx] 		
	mov	cx,w [cosinus+edi]
	mov	dx,w [cosinus+esi]
	mov	cosx,ax 
	mov	cosy,cx           
	mov 	cosz,dx
	mov	ebx,ebp
	add	ebx,ebx
;punkt wird jetzt rotiert
	mov	ax,[yaus+ebx]   
	mov	di,cosx          
 	imul	di               
 	shrd	esi,edx,16              
 	mov	si,ax                   
	mov	ax,[zaus+ebx]    
	mov	di,sinx              
 	imul	di                   
	shrd	ecx,edx,16              
	mov	cx,ax                   
	add	esi,ecx                 
	sar	esi,9                   
	mov	a11,si   ;a11:= ( cosx*y + sinx*z)   shr 9;
	mov	ax,[yaus+ebx]    
	mov	di,sinx          
 	imul	di               
      	shrd	esi,edx,16              
	mov 	si,ax                   
	mov	ax,[zaus+ebx]    
	mov	di,cosx          
 	imul	di               
	shrd	ecx,edx,16              
	mov	cx,ax                   
	sub	ecx,esi          
	sar	ecx,9            
	mov	a22,cx  ;a22:=(-sinx*y + cosx*z) shr 9;
	mov	ax,[xaus+ebx]    
	mov	di,cosy           
 	imul	di                
	shrd	esi,edx,16        
	mov	si,ax             
	mov	ax,a22            
	mov	di,siny           
	imul	di                
	shrd	ecx,edx,16            
	mov	cx,ax             
 	sub	esi,ecx           
	sar	esi,9             
	mov	a33,si  ;a33:=( cosy*x - siny*a2 ) shr 9;
	mov	ax,[xaus+ebx]  
	mov	di,siny           
	imul	di                
	shrd	esi,edx,16        
	mov	si,ax             
	mov	ax,a22            
	mov	di,cosy           
 	imul	di                
	shrd	ecx,edx,16        
	mov	cx,ax             
	add	esi,ecx           
	sar	esi,9    
	add	esi,zweg 
 	mov	[zrot+ebx],si  ;rotiertz:=( siny*x   + cosy*a2 ) shr 9
	mov	ax,a33                                                
	mov	di,cosz                                               
	imul	di                                                    
	shrd	esi,edx,16                                            
	mov	si,ax    
	mov	ax,a11   
	mov	di,sinz  
	imul	di       
	shrd	ecx,edx,16
	mov	cx,ax    
	add	esi,ecx  
	sar	esi,9    
	add	esi,xweg 
 	mov	[xrot+ebx],si  ;rotiertx:=( cosz*a3  + sinz*a1 ) shr 9;
	mov	ax,a33                                                 
	mov	di,sinz                                                
	imul	di                                                     
	shrd	esi,edx,16                                             
	mov	si,ax    
	mov	ax,a11     
	mov	di,cosz    
	imul	di         
	shrd	ecx,edx,16  
	mov	cx,ax       
	sub	ecx,esi     
 	sar	ecx,9    
 	add	ecx,yweg 
 	mov	[yrot+ebx],cx  ;rotierty:=(-sinz*a3  + cosz*a1 ) shr 9
	movsx	esi,[zrot+ebx]                                        
 	or	esi,esi
 	jnz	@nichtnull_e
 	inc	esi                                                   
@nichtnull_e:                  
 	cmp 	esi,0          
 	jns	@nichtnegativ_e
 	neg    	esi         
@nichtnegativ_e:            
	movsx	eax,[xrot+ebx]
	sal	eax,8        
	mov	edx,eax     
	sar	edx,31      
	idiv	esi         
	add	ax,linksrechts
	mov	[xanz+ebx],ax  ;xx[pixel]:=xraus+(longint(rotiertx) shl 8) div rotiertz;
	movsx	eax,[yrot+ebx]
	sal	eax,8       
	mov	edx,eax     
	sar	edx,31      
	idiv	esi         
	add	ax,obenunten
	mov	[yanz+ebx],ax   ;yy[pixel]:=yraus+(longint(rotierty) shl 8) div rotiertz;
    	popad               
ret                         
                            
;
; rotiert alle normalenvektoren 
; IN                                                                  
;  ebx=gradx                                                          
;  edi=grady                                                          
;  esi=gradz                                                          
;
rotatenormals_all:  
      	pushad          
      	movzx	ebx,anzahlvektor
 	add	ebx,ebx           
@next_normals:         
	sub	ebx,2  
	mov	ax,[normaley+ebx]
	mov	di,cosx
 	imul	di
	shrd	esi,edx,16
 	mov	si,ax
	mov	ax,[normalez+ebx]
	mov	di,sinx      
	imul	di      
	shrd	ecx,edx,16   
	mov	cx,ax        
	add	esi,ecx 
	sar	esi,9
	mov	a11,si   ;a11:= ( cosx*y + sinx*z)   shr 9;
	mov	ax,[normaley+ebx]
	mov	di,sinx      
	imul	di           
      	shrd	esi,edx,16   
	mov 	si,ax      
	mov  	ax,[normalez+ebx]
	mov	di,cosx    
	imul	di         
	shrd	ecx,edx,16 
	mov	cx,ax      
	sub	ecx,esi  
	sar	ecx,9   
	mov	a22,cx  ;a22:=(-sinx*y + cosx*z) shr 9;
	mov	ax,[normalex+ebx]
	mov	di,cosy    
	imul	di         
	shrd	esi,edx,16 
	mov	si,ax      
	mov	ax,a22     
	mov	di,siny  
	imul	di       
	shrd	ecx,edx,16
	mov	cx,ax   
 	sub	esi,ecx      
	sar	esi,9
	mov	a33,si  ;a33:=( cosy*x - siny*a2 ) shr 9;
                      
 	mov	ax,si
 	mov	di,cosz
	imul	di
	shrd	esi,edx,16
	mov	si,ax        
	mov	ax,a11       
	mov	di,sinz      
	imul	di           
	shrd	ecx,edx,16   
	mov	cx,ax        
	add	esi,ecx          
	sar	esi,9
	add	esi,256
	shr	ebx,1
	mov	al,b [arcus+esi]
	mov	[normrotx+ebx],al  ;rotiertx:=( cosz*a3  + sinz*a1 ) shr 9;
	                       
	mov	ax,a33        
	mov	di,sinz       
	imul	di            
	shrd	esi,edx,16    
	mov	si,ax         
	mov	ax,a11        
	mov	di,cosz       
	imul	di            
	shrd	ecx,edx,16    
	mov	cx,ax         
	sub	ecx,esi       
	sar	ecx,9
	add 	ecx,256
	mov    	al,b [arcus+ecx]
	mov	[normroty+ebx],al  ;rotierty:=(-sinz*a3  + cosz*a1 ) shr 9
	add	ebx,ebx             
    	jne  	@next_normals      
    	popad                      
ret                                

;
; rotiert einen normalenvektor
; IN                                                                  
;  ebx=gradx                                                          
;  edi=grady                                                          
;  esi=gradz                                                          
;
rotatenormals:
      	pushad                
	mov	ebx,ebp
 	add	ebx,ebx
;normalenvektor wird jetzt rotiert
	mov	ax,[normaley+ebx]                                            
	mov	di,cosx                                                      
 	imul	di                
	shrd	esi,edx,16        
 	mov	si,ax             
	mov	ax,[normalez+ebx] 
	mov	di,sinx           
	imul	di                
	shrd	ecx,edx,16        
	mov	cx,ax             
	add	esi,ecx           
	sar	esi,9             
	mov	a11,si   ;a11:= ( cosx*y + sinx*z)   shr 9;
	mov	ax,[normaley+ebx]
	mov	di,sinx      
	imul	di           
      	shrd	esi,edx,16   
	mov 	si,ax      
	mov  	ax,[normalez+ebx]
	mov	di,cosx    
	imul	di         
	shrd	ecx,edx,16 
	mov	cx,ax      
	sub	ecx,esi  
	sar	ecx,9   
	mov	a22,cx  ;a22:=(-sinx*y + cosx*z) shr 9;
	mov	ax,[normalex+ebx]
	mov	di,cosy    
	imul	di         
	shrd	esi,edx,16 
	mov	si,ax      
	mov	ax,a22     
	mov	di,siny           
	imul	di                
	shrd	ecx,edx,16        
	mov	cx,ax             
 	sub	esi,ecx           
	sar	esi,9             
	mov	a33,si  ;a33:=( cosy*x - siny*a2 ) shr 9;
                                  
 	mov	ax,si             
 	mov	di,cosz           
	imul	di                
	shrd	esi,edx,16        
	mov	si,ax             
	mov	ax,a11            
	mov	di,sinz           
	imul	di                
	shrd	ecx,edx,16        
	mov	cx,ax             
	add	esi,ecx           
	sar	esi,9             
	add	esi,256           
	shr	ebx,1
	mov	al,b [arcus+esi]  
	mov	[normrotx+ebx],al  ;rotiertx:=( cosz*a3  + sinz*a1 ) shr 9;
	                          
	mov	ax,a33            
	mov	di,sinz           
	imul	di                
	shrd	esi,edx,16        
	mov	si,ax             
	mov	ax,a11            
	mov	di,cosz           
	imul	di                
	shrd	ecx,edx,16        
	mov	cx,ax             
	sub	ecx,esi           
	sar	ecx,9             
	add 	ecx,256
	mov    	al,b [arcus+ecx]  
	mov  	[normroty+ebx],al  ;rotierty:=(-sinz*a3  + cosz*a1 ) shr 9
    	popad
ret                                

;
; berechnet alle minimas und maximas (x+y) und saved es in miny minx maxy maxx
; IN  EBX=FACENR                                                  
; OUT MINY                                                        
;
calcmaximas:                                                      
       	pushad           
    	movzx 	esi,[face+ebx*8]  
    	movzx	edi,[face+ebx*8+2]
	movzx	ebx,[face+ebx*8+4]
	add 	esi,esi                                           
	add	edi,edi                                           
	add	ebx,ebx           
	cmp	[zrot+esi],0      
 	jl	@ist_nicht_sichtbar
 	cmp	[zrot+edi],0       
 	jl	@ist_nicht_sichtbar
    	cmp	[zrot+ebx],0      
    	jl 	@ist_nicht_sichtbar
    	jmp	@ist_noch_sichtbar
    	@ist_nicht_sichtbar:    
    	 	 	popad      
    	 		stc        
    	 	   	ret   	   
    	@ist_noch_sichtbar:        
    	 	mov    	dx,10000
	 	mov	ax,[yanz+esi]                             
		cmp	dx,ax                                     
		jle	@weiter1_minimumy1                        
			mov  	dx,ax                             
	@weiter1_minimumy1:                                       
		mov	ax,[yanz+edi]                             
		cmp	dx,ax                                     
	   	jle	@weiter3_minimumy1                        
			mov	dx,ax                             
	@weiter3_minimumy1:                                       
		mov	ax,[yanz+ebx]                             
		cmp	dx,ax                                     
		jle	@ende_minimumy1                           
			mov	dx,ax                             
	@ende_minimumy1:                                          
		cmp	dx,yviewmax                               
    		jng	@zu_ymax                                  
		 	popad                                     
    			stc                                       
	 		ret   	                                  
	@zu_ymax:                                                 
 	 	cmp	dx,yviewmin                               
 		jge    	nichtoben_raus                            
 		mov    	dx,yviewmin                               
 		nichtoben_raus:                                   
		mov	miny,dx                                   
                                                                  
		mov	dx,0                                      
		mov	ax,[yanz+esi]                             
		cmp	dx,ax                                     
		jge	@weiter1_maximumy1                        
		  	      	mov	dx,ax                     
	@weiter1_maximumy1:                                       
		mov	ax,[yanz+edi]                             
		cmp	dx,ax                                     
		jge	@weiter3_maximumy1                        
			      	mov	dx,ax                     
	@weiter3_maximumy1:                                       
		mov	ax,[yanz+ebx]                             
		cmp	dx,ax                                     
		jge @ende_maximumy1                               
			mov	dx,ax                             
	@ende_maximumy1:                                          
		dec	dx                                        
		cmp	dx,yviewmin                               
		jnl	@zu_xmin                                  
			popad                                     
			stc                                       
			ret                                       
	@zu_xmin:                                                 
 		cmp    	dx,yviewmax                               
 	     	jle 	nichtunten_raus                           
 		mov	dx,yviewmax                               
 		nichtunten_raus:                                  
		mov	maxy,dx                                   
		                                                  
		mov	dx,10000
		mov	ax,[xanz+esi]
		cmp	dx,ax                                     
		jle	@weiter1_minimumx1                        
		   	mov    	dx,ax                             
	@weiter1_minimumx1:                                       
		mov	ax,[xanz+edi]
		cmp	dx,ax                                     
		jle	@weiter3_minimumx1
			mov  	dx,ax     
	@weiter3_minimumx1:               
		mov	ax,[xanz+ebx]     
		cmp	dx,ax             
		jle	@ende_minimumx1   
		       	mov 	dx,ax     
	@ende_minimumx1:                  
		cmp	dx,xviewmax       
		jng	@zu_xmax          
			popad             
			stc                                       
			ret               
	@zu_xmax:                         
		mov	dx,0              
		mov	ax,[xanz+esi]                             
		cmp	dx,ax             
		jge	@weiter1_maximumx1
			mov	dx,ax     
	@weiter1_maximumx1:               
		mov	ax,[xanz+edi]     
		cmp	dx,ax             
		jge	@weiter3_maximumx1
			mov	dx,ax     
	@weiter3_maximumx1:               
		mov	ax,[xanz+ebx]     
		cmp	dx,ax             
		jge	@ende_maximumx1   
			mov	dx,ax     
	@ende_maximumx1:                          
		dec    	dx                
 		cmp	dx,xviewmin       
		jnl	@alles_fertig     
			popad             
			stc               
			ret               
	@alles_fertig:                    
	popad                             
	clc                               
ret                                       
                                          
;
; setzt bild ins video ram                
;
setze:                                    
     	    	mov	edi,video
	 	mov	esi,fertigbild                               
		mov	ecx,xaufl*yaufl/4
	 	rep	movsd                                        
	 	mov	edi,fertigbild                               
 	 	mov	ecx,xaufl*yaufl/4
 	 	xor 	eax,eax  
 	 	rep	stosd                                        
ret                                
;
; setzt bild mit blur ins video ram
;
setze_blur:                      
    	pushad                           
   	mov	esi,fertigbild
   	mov	edi,video
	mov   	ecx,xaufl*yaufl/4
	@@loopblur:                      
	   	mov  	eax,[edi]         
		mov  	ebx,[esi]         
		shr 	al,1             
    		shr 	bl,1             
		shr 	ah,1                      
		shr 	bh,1 
		rol	eax,16
		rol	ebx,16
		shr 	al,1             
    		shr 	bl,1             
		shr 	ah,1             
		shr 	bh,1
		rol	eax,16
		rol	ebx,16		
		add 	eax,ebx            
		mov 	[edi],eax         
		add 	edi,4
		add 	esi,4            
		dec 	ecx              
		jnz  	@@loopblur       
		sub	esi,xaufl*yaufl                  
      		mov	ecx,xaufl*yaufl/4
		xor	eax,eax  
		mov	edi,esi  
		rep	stosd                     
	       	popad                    
ret                              

;
; setzt bild ins video ram mit hintergrund
;
setze_hinter:            
      	pushad           
   	mov	edi,video      
   	mov	esi,fertigbild
   	mov	ecx,xaufl*yaufl/4
   	rep	movsd                         
   	mov   	edi,fertigbild
   	mov	esi,hintergrund               
   	mov	ecx,xaufl*yaufl/4
   	rep	movsd                         
	popad                                      
ret                                                
                         
;
; loescht das links und rechts array 
; IN miny  maxy              
;
loeschearray:                                     
	pushad           
	lea 	edi,links
	movzx	ebx,miny 
	add	ebx,ebx  
	add	edi,ebx  
	mov	cx,maxy  
	sub	cx,miny  
	add	cx,2     
	movzx	ecx,cx   
	mov	edx,ecx  
	mov	ax,xviewmax+1
	rep	stosw    
	lea	edi,rechts
	add	edi,ebx  
	mov	ecx,edx  
	mov	ax,xviewmin
	rep	stosw    
	popad            
ret                                  

;
; berechnet sichtbarkeit              
; IN ebx - facenr                     
; OUT   - cx<0 sichtbar              
; OUT   - cx>=0 nicht sichtbar                                 
;
sichtbar:                                                      
      	pushad         
	movzx ebp,[face+ebx*8]
	movzx edi,[face+ebx*8+2]
	movzx esi,[face+ebx*8+4]
	mov ax,[xanz+esi*2]  
	sub ax,[xanz+ebp*2]                                               
	mov bx,[yanz+edi*2]                                      
	sub bx,[yanz+ebp*2]                                      
	imul bx                    
	shrd ecx,edx,16            
	mov cx,ax                  
	mov ax,[xanz+edi*2]
	sub ax,[xanz+ebp*2]          
	mov bx,[yanz+esi*2]          
	sub bx,[yanz+ebp*2]          
	imul bx     
	shrd esi,edx,16   
	mov si,ax                     
	sub ecx,esi       
        mov view,ecx
	popad          
ret                    

lm	dd	(?)                            
rm    	dd	(?)
quicksort:                 
     	push	si
	mov  	esi,lm     
	mov	edi,rm     
;{hilf:=zrichtung[(li+re) shr 1];
;test:=zrot[face[hilf,1]]+zrot[face[hilf,2]]+zrot[face[hilf,3]];}
	mov	ebx,esi    
	add	ebx,edi    
	shr	ebx,1      
	mov	ax,[zrichtung+ebx*2]
	mov	bx,[face+eax*8]
	mov	cx,[zrot+ebx*2]       
	mov	bx,[face+eax*8+2]
	add	cx,[zrot+ebx*2]
	mov	bx,[face+eax*8+4]
	add	cx,[zrot+ebx*2]
	looop:                  
	 	cmp   	si,di                  
		jg	loop0   
		mov	ax,[zrichtung+esi*2]
		loop1:                          
		 	mov  	bx,[face+eax*8]
			mov	dx,[zrot+ebx*2] 
	   		mov	bx,[face+eax*8+2]
			add	dx,[zrot+ebx*2]
			mov	bx,[face+eax*8+4]
			add	dx,[zrot+ebx*2]
			cmp	dx,cx          
			jge	eloop1         
			inc	si
			mov	ax,[zrichtung+esi*2]
		jmp	loop1                  
	eloop1:                  
		mov    	ax,[zrichtung+edi*2]
		loop2:           
			mov	bx,[face+eax*8]
	      		mov	dx,[zrot+ebx*2]
			mov	bx,[face+eax*8+2]
			add	dx,[zrot+ebx*2]
		  	mov	bx,[face+eax*8+4]
			add	dx,[zrot+ebx*2]
			cmp	dx,cx
	      		jle	eloop2
			dec	di
			mov	ax,[zrichtung+edi*2]
		jmp	loop2    
	eloop2:                  
		cmp	si,di
		jg	eloop3   
		mov	ax,[zrichtung+esi*2]
		mov	dx,[zrichtung+edi*2]
		mov	[zrichtung+esi*2],dx
		mov	[zrichtung+edi*2],ax
		inc	esi
		dec	edi
	eloop3:              
		jmp	looop
	loop0:               
		cmp	lm,edi                   
		jge	norekurs1
		push	rm 
		mov	rm,edi
		call	quicksort
		pop	rm  
		mov	edi,rm
	norekurs1:       
		cmp	esi,rm
		jge	norekurs2
		push	lm 
		mov	lm,esi
		call	quicksort
		pop	lm  
		mov	esi,lm
	norekurs2:         
	pop si
ret                            
                                      
filter_sichtbare_faces:        
      	movzx	ebx,anzahlfaces
      	dec	ebx
      	mov   	ecx,-1
@face_loop_xy:
      	call   	sichtbar
 	cmp 	view,0  
 	jl	@noview 
	call	calcmaximas
	jc  	@noview 
 	inc	ecx     
	mov	[zrichtung+ecx*2],bx
	mov	ax,miny 
	mov	[sortminimas+ebx*4],ax
	mov	ax,maxy 
	mov	[sortminimas+ebx*4+2],ax
	@noview:        
	dec	ebx     
   	jns	@face_loop_xy
   	mov	anzahlsichtbar,cx
ret                     
                        
filter_sichtbare_faces_loch:
      	movzx	ebx,anzahlfaces
      	dec	ebx        
      	mov   	ecx,-1     
@face_loop_xy_loch:        
	call	calcmaximas
	jc  	@noview_loch
 	inc	ecx               
	mov	[zrichtung+ecx*2],bx
	mov	ax,miny           
	mov	[sortminimas+ebx*4],ax
	mov	ax,maxy           
	mov	[sortminimas+ebx*4+2],ax
	@noview_loch:             
	dec	ebx               
   	jns	@face_loop_xy_loch
   	mov	anzahlsichtbar,cx
ret                     
                                        
;
; ldt objeckt in die arrays esi=adress fuer objekt
;                                                  
;
loadobjekt:                                        
        cld                           
        mov		ax,[esi]  
        inc		ax        
        mov		anzahlfaces,ax
        add		esi,2     
        mov		ax,[esi]  
        inc		ax             
        mov		anzahlvektor,ax                   
	add  		esi,2                             
	movzx		ecx,ax    
	mov		edx,ecx                             
	lea	  	edi,xaus  
	rep		movsw          ; xwerte eingelesen!
	mov		ecx,edx                                         
	lea 		edi,yaus
	rep		movsw          ; ywerte eingelesen!  
	mov		ecx,edx                              
	lea 		edi,zaus   
	rep		movsw          ; zwerte eingelesen!
 	movzx	  	ecx,anzahlfaces
	lea	  	edi,face
	shl		ecx,2
	mov    		edx,ecx
	rep		movsw           ;faces eingelsen  
                                                          
	lea		edi,normalex
	movzx		ecx,anzahlvektor
 	mov		edx,ecx                           
	rep		movsw	    	;xphong eingelesen
	lea		edi,normaley                      
	mov		ecx,edx                           
	rep		movsw	    	;yphong eingelesen
	lea		edi,normalez
	mov		ecx,edx     
	rep		movsw		;zphong eingelesen
	                    
	lea		edi,xtex                          
	movzx		ecx,anzahlvektor
	mov		edx,ecx                           
	rep		movsb           ;xtexture eingelesen!
	mov		ecx,edx                              
	lea		edi,ytex                          
	rep		movsb           ;ytexture eingelesen!
ret                                                          
                                                     
vektorinit:                                               
	getmem		128000 fertigbild
	getmem		65536 orginaltexture
	getmem		65536 loechertexture
	mov		eax,fertigbild
	add		eax,64000
	mov		hintergrund,eax
	mov	   	edi,fertigbild                  
	mov		ecx,16000
	xor		eax,eax
	rep		stosd                           
                                                        
	xor		eax,eax                         
	mov		ecx,eax                         
@loopadr:                                               
	mov		[yadresse+ecx*4],eax            
	add		eax,320                 
	inc		ecx                     
	cmp	   	ecx,200                 
	jl		@loopadr                
        movzx		ecx,anzahlfaces         
@loopd:                                         
       	mov		[zrichtung+ecx*2],cx    
   	dec	   	ecx                     
	jns	      	@loopd                  
	call	      	make_alah_tabelle	
ret                                             
                                                
vesainit:                                       
      	mov	eax,101h+4000h                  
    	call	checkvbemode                    
    	jnc   	@save
    		mov	video,0
 	   	stc                             
 	      	ret                             
 	@save:                                  
 	mov   	video1,eax                      
 	clc        
ret                                             
                                                
vesaset:                                        
	cmp	video1,0                        
	jne	@vesafound
	   	stc
		ret
	@vesafound:                             
	call	setvbemode
	clc                                     
ret                                             
                                                
novesainit:                                     
 	mov	eax,13h                         
 	int	10h                             
 	mov	ax,0ee02h                       
 	int	31h                             
 	mov	eax,0a0000h                     
 	sub	eax,ebx                         
 	mov	video,eax
ret                  
                     
make_alah_tabelle:   
 	mov	ecx,65535
@loop_make_alah:                       
        cmp 	cl,0     
	jnz   	@wwww                
	mov	[alah_tabelle+ecx],8
 	jmp	fertig               
	@wwww:                       
	cmp	ch,0                 
	jnz   	@wwwww               
	mov	[alah_tabelle+ecx],16
	jmp	fertig               
	@wwwww:                      
	mov	[alah_tabelle+ecx],0
	fertig:       	                       
	dec	ecx                 
	jnz	@loop_make_alah                
	mov	[alah_tabelle],-1
ret                                            

dy dw 0
y dw 0
ddy dw 0
clear:                     
@repeat:                   
mov	ax,ddy
mov	dy,ax
inc	dy 
mov	ax,dy               
mov	ddy,ax              
mov	y,0                 
	repeat1:                
	call	waitretrace
	call	waitretrace	
	call	waitretrace     
	movzx	edx,dy          
	@draw_loop:             
	   	mov	ax,y    
		add	ax,dx   
		cmp	ax,200  
		jnl	@nicht_line
		mov	ecx,80
		xor	eax,eax
		mov	edi,video
		movzx	ebx,y
		add	ebx,edx
		imul	ebx,320
		add	edi,ebx
		rep	stosd
		@nicht_line:
		dec 	edx
		jns	@draw_loop 
	
	dec	dy      
	add	y,10
	cmp	dy,0    
	jne	repeat1 
	cmp	dy,0   
	jne	@repeat         
	cmp	y,280           
   	jne	@repeat    
ret

aufbau:    
mov	dy,0
mov	ddy,0
mov	y,0
@repeat_aufbau:                        
mov    	ax,ddy                         
mov	dy,ax                          
inc	dy                             
mov	ax,dy                          
mov	ddy,ax                         
mov	y,0                            
	repeat1_aufbau:                
	call	waitretrace
	call	waitretrace	
	call	waitretrace		
	movzx	edx,dy                 
	@draw_loop_aufbau:             
	   	mov 	ax,y           
		add	ax,dx          
		cmp	ax,200
		jnl	@nicht_line_aufbau
		mov	ecx,80            
		mov	edi,video
		mov	esi,hintergrund
		movzx	ebx,y
		add	ebx,edx        
		imul	ebx,320        
		add	edi,ebx        
		add	esi,ebx        
		rep	movsd          
		@nicht_line_aufbau:    
		dec 	edx               
		jns	@draw_loop_aufbau 
	                                 
	dec	dy            
	add	y,10
	cmp	dy,0          
	jne	repeat1_aufbau
	cmp	dy,0                     
	jne	@repeat_aufbau
	cmp	y,280         
   	jne	@repeat_aufbau
ret                           

                     
;
; zeit                   
; In:-                   
; Out:-                              
;
zeit:
	pushfd
      	push	eax ebx
      	inc	timer                
      	cmp	backtimer,1          
      	jl  	@@nozero             
	      	sub    	backtimer,1  
      	@@nozero:    
      	cmp	backtimer1,1
      	jl  	@@nozero1
	      	sub    	backtimer1,1
      	@@nozero1:   
                     
                     
      	             
	mov    	eax,ablaufz
	movzx  	ebx,w [ablauf_bump_explode+eax*2]
	cmp  	rowsplayed,ebx
 	jne    	@backtimersetze
	   	mov    	backtimer,40
	   	inc    	ablaufz
	@backtimersetze:
      	             
	cmp  	rowsplayed,28*64+3
	jne	@jetz_raus_anfang 
		mov    	backtimer,600
	@jetz_raus_anfang:        
       	cmp 	rowsplayed,18*64+59;15
       	jne	@nicht_anfang1    
       	   	mov   	backtimer,255
       	@nicht_anfang1:           
                                     
  	cmp	rowsplayed,22*64+52  
  	jne	@nicht_anfang     
  	      	mov    	backtimer,400
  	@nicht_anfang:               
	                             
      	mov   	al,20h               
      	out	20h,al               
 	pop  	ebx eax           
    	popfd                     
iret                 
                                  
                                  
;
; starttimer                 
; In:-                      
; Out:-              
;
starttimer:          
	cli                
	mov	al,36h
	out	43h,al
	mov	al,0    ;169  ;0
	out	40h,al          
	mov	al,64   ;4    ;64
	out	40h,al
                     
	mov	bl,8                    ; BL = int number.
	mov	ax,0204h
	int	31h                     ; Call the service.
	mov	dword ptr timerint,edx  ; Save vector as a 48 bit far
	mov	word ptr timerint+4,cx  ;  pointer.
                     
	mov	bl,8                    ; BL = int number
	mov	edx,offset zeit         ; EDX = offset of int vector
	mov	cx,cs                   ; CX = selector value
	mov	ax,0205h
	int	31h                     ; Call the service.
                     
	sti          
ret                  
                     
;
; stoptimer          
; In:-               
; Out:-              
;
stoptimer:           
	cli          
	mov	al,36h
	out	43h,al
	xor	al,al
	out	40h,al
	out	40h,al
                     
	mov	bl,8                    ; BL = int number
	mov	edx,dword ptr timerint  ; Get vector as a 48 bit far
	mov	cx,word ptr timerint+4
	mov	ax,0205h
	int	31h                     ; Call the service.
	sti          
ret                  
                     
tasten:                          
      	push    ax   
      	mov	al,20h
      	out	20h,al
      	in   	al,60h
      	cmp     al,01             
	je      esctaste          
	pop	ax    
	iret                      
	esctaste:                     
	pop	ax    
	call	textmodus                  
	writestr 'Demo aborted!'
	writestr 'Strontium 90 prod. for mekka96 at march96'
	writestr 'got second in demo compo'
	call	p32_stop
	call	p32_close
	call	stoptimer
	call	tastenein
	call  	exitdos
                                  
;
; tastenaus                       
; In:-                           
; Out:-                          
;
tastenaus:                       
	cli                      
	mov	al,36h           
	out	43h,al           
	mov	al,169           
	out	40h,al           
	mov	al,4             
	out	40h,al                  
                                        
	mov	bl,9                    ; BL = int number.
	mov	ax,0204h                
	int	31h                     ; Call the service.
	mov	dword ptr tastenint,edx ; Save vector as a 48 bit far
	mov	word ptr tastenint+4,cx  ;  pointer.
                                        
	mov	bl,9                    ; BL = int number
	mov	edx,offset tasten       ; EDX = offset of int vector
	mov	cx,cs                   ; CX = selector value
	mov	ax,0205h                
	int	31h                     ; Call the service.
                                        
	sti                             
ret                                     
                                        
;
; tastenein                             
; In:-                                  
; Out:-                                 
;
tastenein:
	cli                             
	mov	al,36h                  
	out	43h,al                  
	xor	al,al                   
	out	40h,al                  
	out	40h,al                  
                                        
	mov	bl,9                    ; BL = int number
	mov	edx,dword ptr tastenint ; Get vector as a 48 bit far
	mov	cx,word ptr tastenint+4
	mov	ax,0205h         
	int	31h                     ; Call the service.
                                 
	sti                      
ret                  
