;
; fuellt face mit text_phong mapping        
;                                                              
;
filltext_phong:                             
    	 	pushad                               
    		movzx 	ecx,miny                     
    	fillingloop_text_phong:                           
		mov 	bp,[rechts+ecx*2]                      
 		sub 	bp,[links+ecx*2]             
 		or 	bp,bp                        
 		jle	@nothingtodraw_text_phong    
                                                     
		mov 	ax,[rechtsnx+ecx*2]          
		mov 	bx,[linksnx+ecx*2]     ;ebx=xstart
		sub 	ax,bx                        
		cwd                                  
		idiv 	bp                           
 		shrd	dummydword,eax,16
		shl 	ebx,16
		mov 	ax,[rechtsny+ecx*2]
		mov 	bx,[linksny+ecx*2]          ;bx=ystart
    		sub   	ax,bx
		cwd          
    		idiv 	bp                           ;si=yf:=(yee-yaa) div xl;  geht nach edx
		mov	w dummydword,ax
 		mov 	ax,[rechtstexx+ecx*2]             
		mov 	dx,[linkstexx+ecx*2]     ;edx=xstart
		sub 	ax,dx                             
		shl 	edx,16                            
		cwd                                       
		idiv 	bp                                
		shrd	dummydword1,eax,16                
		mov 	ax,[rechtstexy+ecx*2]             
		mov 	dx,[linkstexy+ecx*2]    ;dx=ystart
		sub   	ax,dx                             
		cwd                                       
		idiv 	bp                   ;si=yf:=(yee-yaa) div xl;  geht nach edx
		mov	w dummydword1,ax                  
 		mov	dx,[linkstexy+ecx*2]    ;dx=ystart
                                                          
                                                                                             
		mov 	edi,fertigbild                    
		add 	edi,[yadresse+ecx*4]                                       
		movsx 	eax,[links+ecx*2]                                          
 		add 	edi,eax                                                    
		push 	ecx                 ;yzaehler retten da waagerechte beginnt
                                                          
                                             ;CLIPPING START
                mov	ax,[rechts+ecx*2]                 
 		cmp	ax,xviewmax+1                     
		jl 	@nicht_rechts_raus_text_phong     
			mov    	bp,xviewmax+1             
			sub    	bp,[links+ecx*2]          
 		@nicht_rechts_raus_text_phong:            
		mov	ax,[links+ecx*2]                  
 		cmp	ax,xviewmin                       
 		jge	@nicht_links_raus_text_phong      
 			mov	cx,xviewmin                       
 			sub	cx,ax                             
 			@nachrechts_text_phong:           
 			dec   	bp                                
 			inc	edi                               
 			add  	ebx,dummydword            
 			add	edx,dummydword1           
 			dec	cx                                
 			jnz	@nachrechts_text_phong                  
 		@nicht_links_raus_text_phong:             ;CLIPPING ENDE
		xor	eax,eax                           
	 	shr 	bp,1                              
		jnc 	@kein_byte_text_phong             
			add 	edx,dummydword1           
			add    	ebx,dummydword            
			mov 	ecx,edx                   
			shr 	ecx,16                    
			mov 	cl,dh                     
			mov 	al,[texture+ecx]         ;esi=auf texture zeigen
			shl	ax,5                      
				                          
			mov	ecx,ebx                                         
			shr	ecx,16                    
			mov	cl,bh                     
			add	al,[phongmap+ecx]         
			mov	al,[shadingstufe+eax]     
 			mov 	[edi],al
			inc  	edi                       
		@kein_byte_text_phong:                    
		or	bp,bp                                              
		jle	@endeloop_text_phong                               
 		@nextstep_text_phong:                                      
			xor	eax,eax   
		   	add    	edx,dummydword1
		   	add    	ebx,dummydword
			mov 	ecx,edx
 			shr 	ecx,16
 		   	mov 	cl,dh     
			mov  	al,[texture+ecx]         ;ecx=auf texture zeigen
			shl	ax,5   
 			mov	ecx,ebx
 			shr	ecx,16
 			mov	cl,bh     
 			add	al,[phongmap+ecx]
 			mov	al,[shadingstufe+eax]
 	 		mov	si,ax     
 	 		xor	ah,ah          
 			   	       	       	                           
                                                                           
 			add	edx,dummydword1                            
 			add   	ebx,dummydword     ;inc(xy,xyfak)
			mov 	ecx,edx
 			shr  	ecx,16
 			mov 	cl,dh                                      
 			mov 	al,[texture+ecx]    ;ecx=auf texture zeigen
			shl	ax,5                                       
                                                                           
 			mov	ecx,ebx
 			shr	ecx,16
 			mov	cl,bh     
 			add	al,[phongmap+ecx]                          
 			mov	ch,[shadingstufe+eax]                      
 			mov	ax,si                                      
 			mov	ah,ch                   
			mov 	[edi],ax                
			add 	edi,2                   
	 		dec 	bp                      
	 	  	jnz 	@nextstep_text_phong    
		@endeloop_text_phong:                   
		pop 	ecx            ;yzaehler restaurieren
		@nothingtodraw_text_phong:                         
		inc 	ecx                                  
		cmp 	cx,maxy       ;ende erreicht?        
	 	jle 	fillingloop_text_phong    
	 	popad                                                   
ret                                                                     

;
; fuellt face mit bump mapping
;                                                              
;
fillbump:
    	 	pushad                      
    		movzx 	ecx,miny
    	fillingloop_bump:                  
		mov 	bp,[rechts+ecx*2]  
 		sub 	bp,[links+ecx*2]   
 		or  	bp,bp              
 		jle	@nothingtodraw_bump
                                                    
		mov 	ax,[rechtsnx+ecx*2]
		mov 	bx,[linksnx+ecx*2]     ;ebx=xstart
		sub 	ax,bx                       
		cwd                                 
		idiv 	bp                          
 		shrd	dummydword,eax,16  
		shl   	ebx,16             
		mov   	ax,[rechtsny+ecx*2]         
		mov   	bx,[linksny+ecx*2]          ;bx=ystart
    		sub   	ax,bx                       
		cwd                                 
    		idiv 	bp                           ;si=yf:=(yee-yaa) div xl;  geht nach edx
		mov	w dummydword,ax             
		sub 	ebx,dummydword               ; ebx=startxy edx=faktorxy
		mov 	ax,[rechtstexx+ecx*2]       
		mov 	dx,[linkstexx+ecx*2]     ;edx=xstart
		sub 	ax,dx                       
		shl 	edx,16                 
		cwd                                
		idiv 	bp                     
		shrd	dummydword1,eax,16     
		mov 	ax,[rechtstexy+ecx*2]  
		mov 	dx,[linkstexy+ecx*2]    ;dx=ystart
		sub   	ax,dx                  
		cwd                                       
		idiv 	bp                   ;si=yf:=(yee-yaa) div xl;  geht nach edx
		mov   	w dummydword1,ax            
		mov   	dx,[linkstexy+ecx*2]    ;dx=ystart    
		sub   	edx,dummydword1               ; edx=startxy dummy=faktorxy
                                                    
                                                                                             
		mov 	edi,fertigbild     
		mov 	eax,[yadresse+ecx*4]                                       
		add 	edi,eax                                                    
		movsx 	eax,[links+ecx*2]                                          
 		add 	edi,eax                                                    
		push 	ecx                 ;yzaehler retten da waagerechte beginnt
                                                
                                             ;CLIPPING START
                mov	ax,[rechts+ecx*2]
 		cmp	ax,xviewmax+1           
		jl	@nicht_rechts_raus_bump
		      	mov    	bp,xviewmax+1   
			sub    	bp,[links+ecx*2]
 		@nicht_rechts_raus_bump:
		mov   	ax,[links+ecx*2]            
 		cmp	ax,xviewmin             
 		jge	@nicht_links_raus_bump
 			mov	cx,xviewmin                                       
 			sub	cx,ax                             
 			@nachrechts_bump:
 			dec   	bp                                
 			inc	edi                               
 			add  	ebx,dummydword
 			add	edx,dummydword1
 			dec	cx                                
 			jnz	@nachrechts_bump
 		@nicht_links_raus_bump:             ;CLIPPING ENDE
		shr 	bp,1                   
		jnc 	@kein_byte_bump
			add 	ebx,dummydword  
			add	edx,dummydword1 
			mov 	ecx,edx         
			shr 	ecx,16          
		      	mov 	cl,dh               
 		      	mov	esi,ecx      ;offset fuer texture in esi
			mov	ecx,ebx                                 
			shr	ecx,16                                  
			mov	cl,bh                                   
 			add	cx,[bumpnormals+esi*2]   ;lenke normvektor aus
 			mov	al,[phongmap+ecx]    
 			mov 	[edi],al            
 			inc  	edi                 
		@kein_byte_bump:                    
		or	bp,bp                       
		jle	@endeloop_bump              
		@nextstep_bump:                     
		   	add    	ebx,dummydword      
		   	add    	edx,dummydword1     
			mov   	ecx,edx             
 			shr 	ecx,16              
		   	mov 	cl,dh               
 			mov	esi,ecx   ;offset fuer texture in esi
			mov	ecx,ebx                                 
 			shr	ecx,16                                  
 			mov	cl,bh                                
			add	cx,[bumpnormals+esi*2]  ;lenke normvektor aus 
 			mov	al,[phongmap+ecx]                             
                                                                             
 			add   	ebx,dummydword     ;inc(xy,xyfak)            
 			add	edx,dummydword1                              
			mov 	ecx,edx                                      
 			shr  	ecx,16                                       
			mov 	cl,dh                                        
 			mov	esi,ecx       ;offset fuer texture in esi    
 			mov	ecx,ebx                                      
 			shr	ecx,16                                        
 			mov	cl,bh                                         
 			add	cx,[bumpnormals+esi*2]   ;lenke normvektor aus
 			mov	ah,[phongmap+ecx]   
 			mov 	[edi],ax 			
			add 	edi,2
	 		dec 	bp                  
 	 	  	jnz    	@nextstep_bump      
		@endeloop_bump:                     
		pop 	ecx            ;yzaehler restaurieren
		@nothingtodraw_bump:
		inc 	ecx                                  
		cmp 	cx,maxy       ;ende erreicht?
	 	jle 	fillingloop_bump
	 	popad                                                   
ret                                                                     
                                
;
; fuellt face mit bump mapping mit loechern
;                                                              
;
fillbump_hole:                  
    	     	pushad                      
    	     	movzx 	ecx,miny            
    	fillingloop_bump_hole:              
		mov 	bp,[rechts+ecx*2]                      
 		sub 	bp,[links+ecx*2]    
 		or  	bp,bp                       
 		jle	@nothingtodraw_bump_hole
                                                    
		mov 	ax,[rechtsnx+ecx*2]     
		mov 	bx,[linksnx+ecx*2]     ;ebx=xstart
		sub 	ax,bx                       
		cwd                                 
		idiv 	bp                          
 		shrd	dummydword,eax,16       
		shl   	ebx,16                  
		mov   	ax,[rechtsny+ecx*2]         
		mov   	bx,[linksny+ecx*2]          ;bx=ystart
    	     	sub   	ax,bx                       
	     	cwd                                 
    		idiv 	bp                           ;si=yf:=(yee-yaa) div xl;  geht nach edx
		mov	w dummydword,ax             
		sub 	ebx,dummydword               ; ebx=startxy edx=faktorxy
		mov 	ax,[rechtstexx+ecx*2]       
		mov 	dx,[linkstexx+ecx*2]     ;edx=xstart
		sub 	ax,dx                       
		shl 	edx,16                  
		cwd                                
		idiv 	bp                      
		shrd	dummydword1,eax,16      
		mov 	ax,[rechtstexy+ecx*2]   
		mov 	dx,[linkstexy+ecx*2]    ;dx=ystart
		sub   	ax,dx                   
		cwd                                       
		idiv 	bp                   ;si=yf:=(yee-yaa) div xl;  geht nach edx
		mov   	w dummydword1,ax            
		mov   	dx,[linkstexy+ecx*2]    ;dx=ystart    
		sub   	edx,dummydword1               ; edx=startxy dummy=faktorxy
                                                    
                                                                                             
		mov 	edi,fertigbild          
		mov 	eax,[yadresse+ecx*4]                                       
		add 	edi,eax                                                    
		movsx 	eax,[links+ecx*2]                                          
 		add 	edi,eax                                                    
		push 	ecx                 ;yzaehler retten da waagerechte beginnt
                                                
                                             ;CLIPPING START
                mov	ax,[rechts+ecx*2]       
 		cmp	ax,xviewmax+1           
		jl	@nicht_rechts_raus_bump_hole
		      	mov    	bp,xviewmax+1       
			sub    	bp,[links+ecx*2]    
 		@nicht_rechts_raus_bump_hole:
		mov   	ax,[links+ecx*2]            
 		cmp	ax,xviewmin                 
 		jge	@nicht_links_raus_bump_hole
 	     		mov	cx,xviewmin                                       
 			sub	cx,ax       
 			@nachrechts_bump_hole:
 			dec   	bp                                
 			inc	edi                               
 			add  	ebx,dummydword
 			add	edx,dummydword1
 			dec	cx                                
 			jnz	@nachrechts_bump_hole
 		@nicht_links_raus_bump_hole:        ;CLIPPING ENDE
 		shr	bp,1     
 		jnc	@nicht_byte_bump_hole
		   	add    	ebx,dummydword      
		   	add    	edx,dummydword1     
			mov    	ecx,edx             
 			shr  	ecx,16              
		   	mov 	cl,dh               
		   	mov 	al,[texture+ecx]    
		   	or	al,al               
	     	   	jz	@loch_da
 	     		mov	esi,ecx   ;offset fuer texture in esi
			mov	ecx,ebx                                 
 			shr	ecx,16              
 			mov	cl,bh               
			add	cx,[bumpnormals+esi*2]  ;lenke normvektor aus
 			mov	al,[phongmap+ecx]   
 			add	al,phongaddi        
			mov	[edi],al            
 	 	  	@loch_da:                   
			inc 	edi                 
                                                    
 		@nicht_byte_bump_hole:              
 		or	bp,bp                       
		jz	@endeloop_bump_hole         
		@nextstep_bump_hole:                
		   	add    	ebx,dummydword      
		   	add    	edx,dummydword1     
			mov   	ecx,edx             
 		 	shr  	ecx,16              
		   	mov 	cl,dh               
		   	mov	al,[texture+ecx]
		   	or 	al,al
		   	jz	@nichts              
	 	     		mov  	esi,ecx   ;offset fuer texture in esi
				mov	ecx,ebx                                 
	 			shr	ecx,16                               
	 			mov	cl,bh                                
				add	cx,[bumpnormals+esi*2]  ;lenke normvektor aus
	 			mov	al,[phongmap+ecx]                    
	 		       	add	al,phongaddi                         
 			@nichts:                                             
 			                                                     
		   	add    	ebx,dummydword                               
		   	add    	edx,dummydword1                              
			mov   	ecx,edx                                      
 			shr  	ecx,16                                          
		   	mov  	cl,dh                                        
		   	mov	ah,[texture+ecx]                             
		   	or	ah,ah                                        
		   	jz 	@nichts1                                     
	 	     	  	mov  	esi,ecx   ;offset fuer texture in esi   
				mov  	ecx,ebx                                 
	 			shr  	ecx,16                                  
	 			mov  	cl,bh                                   
				add  	cx,[bumpnormals+esi*2]  ;lenke normvektor aus
	 			mov  	ah,[phongmap+ecx]                    
	 		   	add  	ah,phongaddi                         
 			@nichts1:                                            
			mov	cl,[alah_tabelle+eax]                        
			xor	ch,ch                                        
			or	cl,cl                                        
			jnz	@nichtword                                   
			mov	[edi],ax
			jmp	@fertig 
			@nichtword:                                          
			js	@fertig 
			rol	ax,cl
			xor	cx,8+16
 			shr	ecx,4
 			mov	b [edi+ecx],al
			@fertig:                                             
			add 	edi,2                                 
	 		dec 	bp                                    
 	 	  	jnz    	@nextstep_bump_hole                   
		@endeloop_bump_hole:                                  
		pop 	ecx            ;yzaehler restaurieren         
		@nothingtodraw_bump_hole:                             
		inc 	ecx                                           
		cmp 	cx,maxy       ;ende erreicht?        
	 	jle 	fillingloop_bump_hole
	 	popad                                                   
ret                                                                     
                                
sprung dw (?)            
dummyy dw (?)                            
dummyx dw (?)                            
drawall_bump_explode:                    
      	movsx	edx,anzahlsichtbar       
	cmp 	edx,0                    
	jge 	@single_face_bump_explode
	    	ret                      
	@single_face_bump_explode:       
	    	movzx	ebx,[zrichtung+edx*2]
 	 	push	edx                  
 		movzx  	esi,[face+ebx*8]     ;1.ecke
		movzx	edi,[face+ebx*8+2]   ;2.ecke
		movzx	ebp,[face+ebx*8+4]   ;3.ecke
 	 	                         
	    	movsx	eax,[sortminimas+ebx*4]
		sub	eax,100          
                shl	eax,8            
		cdq                      
                idiv	sprung           
		add	eax,100          
	    	mov	miny,ax               
		movsx	eax,[sortminimas+ebx*4+2]
		sub	eax,100          
                shl	eax,8            
		cdq                      
                idiv	sprung        
		add	eax,100                  
		mov	maxy,ax                     
 	 	call	loeschearray
 		                      
                                 
 		movsx	eax,[xanz+esi*2]
		sub	eax,160     
		shl	eax,8       
		cdq                 
		idiv   	sprung      
		add	ax,160   
		mov  	dummyx,ax
 	 	movsx	ebx,[yanz+esi*2]
		mov	eax,ebx  
		sub	eax,100  
		shl	eax,8    
		cdq              
		idiv  	sprung   
		add	eax,100  
		mov	dummyy,ax                
 		mov	ax,[xanz+esi*2]
 		mov	bx,[yanz+esi*2]
		sub	dummyx,ax		
		sub	dummyy,bx		
 		mov  	cx,[xanz+edi*2]
 		mov	dx,[yanz+edi*2]
		add	ax,dummyx
		add	bx,dummyy
		add	cx,dummyx
		add	dx,dummyy
	 	call	linietext_phong             
 	 	                                                        
    		xchg	esi,ebp 
	   	mov	ax,[xanz+esi*2]
		mov	bx,[yanz+esi*2]
    		mov	cx,[xanz+edi*2]
 		mov  	dx,[yanz+edi*2]
		add	ax,dummyx
		add	bx,dummyy                
		add	cx,dummyx
		add	dx,dummyy
 		call	linietext_phong             
                                                    
 		xchg	edi,ebp                     
 		mov	ax,[xanz+esi*2]
 	 	mov	bx,[yanz+esi*2]
 	 	mov	cx,[xanz+edi*2]
 	 	mov	dx,[yanz+edi*2]
		add	ax,dummyx
		add	bx,dummyy
		add	cx,dummyx
		add	dx,dummyy
 		call	linietext_phong
                                                                        
 	 	call	fillbump
		pop	edx            
	 	dec	edx                         
	     	jns    	@single_face_bump_explode
ret                                                     
                                                 
drawall_bump:                                    
      	movsx	edx,anzahlsichtbar
	cmp 	edx,0
	jge	@single_face_bump
		ret
	@single_face_bump:                       
	    	movzx	ebx,[zrichtung+edx*2]
 	 	push	edx                  
 		movzx  	esi,[face+ebx*8]     ;1.ecke
		movzx	edi,[face+ebx*8+2]   ;2.ecke
		movzx	ebp,[face+ebx*8+4]   ;3.ecke
 	 	       
	    	mov	ax,[sortminimas+ebx*4]
	    	mov	miny,ax               
		mov	ax,[sortminimas+ebx*4+2]
		mov	maxy,ax                     
 	 	call	loeschearray
 		                      
                                 
 		mov	ax,[xanz+esi*2]
 	 	mov	bx,[yanz+esi*2]
 		mov  	cx,[xanz+edi*2]
 		mov	dx,[yanz+edi*2]
	 	call	linietext_phong             
 	 	                                                        
    		xchg	esi,ebp
	   	mov	ax,[xanz+esi*2]
		mov	bx,[yanz+esi*2]
    		mov	cx,[xanz+edi*2]
 		mov  	dx,[yanz+edi*2]
 		call	linietext_phong             
                                                    
 		xchg	edi,ebp                     
 		mov	ax,[xanz+esi*2]
 	 	mov	bx,[yanz+esi*2]
 	 	mov	cx,[xanz+edi*2]
 	 	mov	dx,[yanz+edi*2]
 		call	linietext_phong
                                                                        
 	 	call	fillbump
		pop	edx            
	 	dec	edx                         
	     	jns    	@single_face_bump
ret                                                     
                               
drawall_bump_hole:            
       	movzx	edx,anzahlsichtbar
	@single_face_bump_hole:   
	    	movzx	ebx,[zrichtung+edx*2]                           
		mov	ax,[sortminimas+ebx*4]
		mov	miny,ax
		mov	ax,[sortminimas+ebx*4+2]
		mov	maxy,ax                     
 	 	call	loeschearray
		mov	phongaddi,0
 	 	call	sichtbar   
 	 	cmp	view,0               
 	 	jge	@nicht_rueckseite
 	 		mov	phongaddi,128
 	 	@nicht_rueckseite: 
 		movzx  	esi,[face+ebx*8]     ;1.ecke
		movzx	edi,[face+ebx*8+2]   ;2.ecke
		movzx	ebp,[face+ebx*8+4]   ;3.ecke
 	 	push	edx                         
 		mov	ax,[xanz+esi*2]                                 
 	 	mov	bx,[yanz+esi*2]                                 
 		mov    	cx,[xanz+edi*2]                                 
 		mov	dx,[yanz+edi*2]                                 
	 	call	linietext_phong             
 	 	                                                        
    		xchg	esi,ebp                     
	   	mov	ax,[xanz+esi*2]                                 
		mov	bx,[yanz+esi*2]                                 
    		mov	cx,[xanz+edi*2]                                 
 		mov    	dx,[yanz+edi*2]             
 		call	linietext_phong             
                                                    
 		xchg	edi,ebp                     
 		mov	ax,[xanz+esi*2]             
 	 	mov	bx,[yanz+esi*2]                                 
 	 	mov	cx,[xanz+edi*2]                                 
 	 	mov	dx,[yanz+edi*2]
 		call	linietext_phong             
                                                                        
 	 	call	fillbump_hole
		pop	edx       
	 	dec	edx                         
   	     	jns    	@single_face_bump_hole
ret
                                               
drawall_text_phong:           
	movzx	edx,anzahlsichtbar     
	@single_face_text_phong:       
		movzx	ebx,[zrichtung+edx*2]                           
		mov	ax,[sortminimas+ebx*4]
		mov	miny,ax           
		mov	ax,[sortminimas+ebx*4+2]
		mov	maxy,ax                     
 	 	call	loeschearray
 		movzx  	esi,[face+ebx*8]     ;1.ecke
		movzx	edi,[face+ebx*8+2]   ;2.ecke
		movzx	ebp,[face+ebx*8+4]   ;3.ecke
 	 	push	edx                         
 		mov	ax,[xanz+esi*2]                                 
 	 	mov	bx,[yanz+esi*2]                                 
 		mov    	cx,[xanz+edi*2]                                 
 		mov	dx,[yanz+edi*2]                                 
	 	call	linietext_phong             
 	 	                                                        
    		xchg	esi,ebp                     
	   	mov	ax,[xanz+esi*2]                                 
		mov	bx,[yanz+esi*2]                                 
    	 	mov	cx,[xanz+edi*2]                                 
 		mov    	dx,[yanz+edi*2]                        
 		call	linietext_phong             
                                                    
 		xchg	edi,ebp                     
 		mov	ax,[xanz+esi*2]             
 	 	mov	bx,[yanz+esi*2]                                 
 	 	mov	cx,[xanz+edi*2]                                 
 	 	mov	dx,[yanz+edi*2]                                 
   		call	linietext_phong             
                                                                        
 	 	call	filltext_phong              
		pop	edx                         
	 	dec	edx                         
     	     	jns    	@single_face_text_phong     
ret                                                     
                                                    
init_bump1:                      
pushad                           
    	xor	eax,eax                                                 
   	xor	ebx,ebx                                        
    	@all_bumpnormals1:       
	        xor	edx,edx                 
	 	dec	bl                      
	 	mov	dl,[texture+ebx]      	
   	     	add	bl,2                    
   	 	sub	dl,[texture+ebx]
   	 	shl	dl,1
 	 	mov	cl,dl
 	 	dec	bl  
   	 	xor	edx,edx                            
   	 	dec	bh                                 
   	 	mov	dl,[texture+ebx]                   
 	 	add	bh,2                               
    	 	sub	dl,[texture+ebx]
    	 	shl	dl,1
  	      	mov	ch,dl     ;zu speichernder y wert  
   	 	dec	bh                                 
   		mov	[bumpnormals+ebx*2],cx             
   		inc	ebx                              
   		cmp	ebx,65536                        
   	jne  	@all_bumpnormals1                        
     	popad                                            
ret                                                      
                                                         
init_bump2:                                              
pushad                                                   
    	xor	eax,eax                                  
   	xor	ebx,ebx                                        
    	@all_bumpnormals2:                               
 	        xor	edx,edx                          
 	  	dec	bl                               
	 	mov	dl,[texture+ebx]      	         
   	     	add	bl,2                             
   	 	sub	dl,[texture+ebx]
    	 	shl	dl,2   	 	
 	 	mov	cl,dl                              
 	 	dec	bl                                 
 		xor	edx,edx                            
   		dec	bh                                 
   	 	mov	dl,[texture+ebx]                   
   	 	add	bh,2                               
    	 	sub	dl,[texture+ebx]
    	 	shl	dl,2
   	      	mov	ch,dl     ;zu speichernder y wert  
   	 	dec	bh                                 
   		mov	[bumpnormals+ebx*2],cx             
   		inc	ebx                                
   		cmp	ebx,65536                          
   	jne  	@all_bumpnormals2                          
     	popad                                              
ret                                                        
